﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Document.UseCase;
using Editor.Document;
using Editor.Numbering;

namespace Editor.Commands.Document.UseCase
{
    public sealed class AddSubflow : ICommand, IDocumentCommand
    {
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public AddSubflow( UseCaseDocument document )
        {
            this.document = document;
        }

        public bool Execute()
        {
            int sectionRow = document.FindSection( ESectionType.SubFlow );

            if( sectionRow == -1 ) return false;

            TemplateRow subflowSection = document[sectionRow] as TemplateRow;

            subflowSection.Add( new MainFlow( new DefaultNumbering("S"), "New Subflow" ) );

            return true;
        }
    }
}
