﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Document;
using Editor.Text.UseCase;
using Editor.Document.UseCase;

namespace Editor.Commands.Document.UseCase
{
    public sealed class AssignActor : ICommand, IDocumentCommand
    {
        private ActorGlyph actorGlyph;
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public AssignActor( UseCaseDocument document, ActorGlyph actorGlyph )
        {
            this.actorGlyph = actorGlyph;
            this.document = document;
        }

        public bool Execute()
        {
            for( int i1 = 0; i1 < document.RowCount; i1++ )
            {
                if( document[i1] is Actors )
                {
                    Actors actors = document[i1] as Actors;
                    ActorGlyph tempGlyph;

                    for( int i2 = 0; i2 < actors.Text.VirtualLength; i2++ )
                    {
                        tempGlyph = actors.Text[i2] as ActorGlyph;

                        if( tempGlyph != null && object.ReferenceEquals( actorGlyph.Actor, tempGlyph.Actor ) ) 
                            return false;
                    }

                    if( actors.Text.VirtualLength == 0 )
                    {
                        actors.Text.InsertGlyph( 0, actorGlyph );
                    }
                    else
                    {
                        actors.Text.BeginChange();

                        actors.Text.InsertString( actors.Text.VirtualLength, ", " );
                        actors.Text.InsertGlyph( actors.Text.VirtualLength, actorGlyph );

                        actors.Text.EndChange( false );

                        
                    }

                    return true;
                }
            }

            return false;
        }
    }
}
