﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Document;
using Editor.Text.UseCase;
using Editor.Commands.Document.Text;
using Editor.Text;

namespace Editor.Commands.Document.UseCase
{
    public sealed class InsertActor : ICommand, IDocumentCommand
    {
        private ActorGlyph actorGlyph;
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public InsertActor( UseCaseDocument document, ActorGlyph actorGlyph )
        {
            this.actorGlyph = actorGlyph;
            this.document = document;
        }

        public bool Execute()
        {
            if( document.Selection.MultiRow ) return false;

            IDocumentRow documentRow = document[document.Selection.StartRow];
            IText actorText = documentRow.Text.CreateInstance();

            actorText.InsertGlyph( 0, actorGlyph );

            if( document.Selection.MultiIndex )
                return document.ExecuteCommand( new TextReplaceText( document, actorText ) );
            else return document.ExecuteCommand( new InsertText( document, actorText ) );
        }
    }
}
