﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Text.UseCase;
using Editor.Project;
using Editor.Document;
using Editor.Text;
using Editor.Commands.Document.Text;

namespace Editor.Commands.Document.UseCase
{
    public sealed class InsertDefinition : ICommand, IDocumentCommand
    {
        private DefinitionGlyph definitionGlyph;
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public InsertDefinition( UseCaseDocument document, DefinitionGlyph definitionGlyph )
        {
            this.definitionGlyph = definitionGlyph;
            this.document = document;
        }

        public bool Execute()
        {
            if( document.Selection.MultiRow ) return false;

            IDocumentRow documentRow = document[document.Selection.StartRow];
            IText definitionText = documentRow.Text.CreateInstance();

            definitionText.InsertGlyph( 0, definitionGlyph );

            if( document.Selection.MultiIndex )
                return document.ExecuteCommand( new TextReplaceText( document, definitionText ) );
            else return document.ExecuteCommand( new InsertText( document, definitionText ) );
        }
    }
}
