﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Text;
using Editor.View;

namespace Editor.Document
{
    public interface IDocumentRow : IChangeHandler
    {
        IDocument Document { get; }
        bool Editable { get; }
        bool Formattable { get; }
        int LeftIndent { get; set; }
        bool Removable { get; }
        int RightIndent { get; set; }

        IText Text { get; set; }

        event EventHandler IndentChanged;
        event EventHandler TextChanged;
    }
}
