﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Editor.Document
{
    public interface ISelection : IChangeHandler
    {
        Brush BackColor { get; }
        int EndIndex { get; set; }
        int EndRow { get; set; }
        bool MultiIndex { get; }
        bool MultiRow { get; }
        bool Reversed { get; }
        int StartIndex { get; set; }
        int StartRow { get; set; }
        Color TextColor { get; }

        void Change( int startRow, int startIndex, int endRow, int endIndex );
        bool Contains( int row, int index );
        bool ContainsRow( int row );
        SSelection GetCurrent();
        SSelection GetOrdered();
    }
}
