﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text;

namespace Editor.Drawing
{
    public class Gdi
    {
        public static TextMetrics GetTextMetrics( Graphics graphics, Font font ) 
        { 
           IntPtr hDC = graphics.GetHdc();
           IntPtr hFont = font.ToHfont();
           TextMetrics textMetrics; 

           try 
           { 
             IntPtr hFontLast = SelectObject( hDC, hFont ); 

             GetTextMetrics( hDC, out textMetrics ); 
             SelectObject( hDC, hFontLast ); 
           } 
           finally 
           {  
             DeleteObject( hFont ); 
             graphics.ReleaseHdc( hDC ); 
           } 

           return textMetrics; 
        } 

        [DllImport("Gdi32.dll", CharSet=CharSet.Unicode)] 
        static extern IntPtr SelectObject( IntPtr hdc, IntPtr hgdiobj ); 

        [DllImport("Gdi32.dll", CharSet=CharSet.Unicode)] 
        static extern bool GetTextMetrics( IntPtr hdc, out TextMetrics lptm ); 

        [DllImport("Gdi32.dll", CharSet=CharSet.Unicode)] 
        static extern bool DeleteObject( IntPtr hdc );
    }
}
