﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Editor.View;

namespace Editor.Text
{
    public interface IStyle : ICloneable<IStyle>, IEquatable<IStyle>, IChangeHandler
    {
        Color BackColor { get; set; }
        bool Bold { get; set; }
        Font Font { get; }
        FontFamily FontFamily { get; set; }
        bool Italic { get; set; }
        string Name { get; set; }
        float Size { get; set; }
        bool Strikeout { get; set; }
        Color TextColor { get; set; }
        bool Underline { get; set; }

        int GetAscent( IView view );
        int GetDescent( IView view );
        int GetHeight( IView view );
    }
}
