﻿using System;
using System.Collections.Generic;
using Editor.Document;
using Editor.View;
using System.Drawing;

namespace Editor.Text
{
    public interface IText : IChangeHandler
    {
        Glyph this[int index] { get; }
        int CharacterLength { get; }
        bool Empty { get; }
        int VirtualLength { get; }

        IText ChangeStyle( int index, int length, short style );
        IText Copy( int index, int length );
        IText CreateInstance();
        short GetInsertStyle( int index );
        short GetStyle( int index );
        Glyph[] GetRange( int index, int length );
        int GetVirtualIndex( int charIndex, out int startIndex, out int endIndex );
        IText InsertCharacter( int index, char character );
        IText InsertGlyph( int index, Glyph glyph );
        IText InsertString( int index, string characters );
        IText InsertText( int index, IText text );
        IText Remove( int index, int length );
    }
}
