﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Text;
using System.Drawing;
using System.Windows.Forms;
using Editor.Document;

namespace Editor.View
{
    public interface IView : IChangeHandler
    {
        IViewRow this[int index] { get; }
        Caret Caret { get; }
        IDocument Document { get; set; }
        Graphics Graphics { get; }
        int RowLevelIndent { get; }
        int Margins { get; }
        int RowCount { get; }
        Size Size { get; }
        IStyleTable StyleTable { get; }

        void Draw( Arguments arguments );
        void DrawString( string text, Font font, Color textColor, Point point );
        void DrawString( string text, Font font, Color textColor, Color backColor, Point point );
        int GetSelectionRow( int y );
        Size MeasureString( string text, Font font );
        void PlaceCaret( int y );
        void Prepare();
        void Redraw();
    }
}
