﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Editor.Project;

namespace UseCaseTool.Forms
{
    public partial class DefinitionForm : Form
    {
        private DictionaryWord dictionaryWord;
        private BindingList<Variation> variations;

        public DictionaryWord Definition 
        {
            get { return dictionaryWord; }
        }

        public DefinitionForm( DictionaryWord word )
        {
            this.dictionaryWord = word;

            InitializeComponent();

            nameTB.Text = word.Name;
            definitionTB.Text = word.Definition;
            variations = word.CloneVariations();
        }

        private void confirmBN_Click(object sender, EventArgs e)
        {
            if( nameTB.Text.Trim() == string.Empty )
            {
                MessageBox.Show( "Word cannot be empty", "Warning", MessageBoxButtons.OK, 
                    MessageBoxIcon.Warning );
                return;
            }

           if( definitionTB.Text.Trim() == string.Empty )
            {
                MessageBox.Show( "Definition cannot be empty", "Warning", MessageBoxButtons.OK, 
                    MessageBoxIcon.Warning );
                return;
            }

           dictionaryWord.Name = nameTB.Text;
           dictionaryWord.Definition = definitionTB.Text;
           dictionaryWord.Variations = variations;

           DialogResult = DialogResult.OK;
        }

        private void variationsBN_Click(object sender, EventArgs e)
        {
            BindingList<Variation> clonedVariations = new BindingList<Variation>();
            for( int i = 0; i < variations.Count; i++ ) clonedVariations.Add( variations[i].Clone() );

            VariationsEditorForm variationsForm = new VariationsEditorForm( clonedVariations );

            DialogResult dialogResult = variationsForm.ShowDialog();

            if( dialogResult == DialogResult.OK )
            {
                variations = variationsForm.Variations;
            }
        }
    }
}
