﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Editor.Project;

namespace UseCaseTool.Forms
{
    public partial class DictionaryForm : Form
    {
        private UseCaseProject project;

        public DictionaryForm( UseCaseProject project )
        {
            this.project = project;

            InitializeComponent();

            wordsLB.DataSource = project.DictionaryWords;
        }

        private void addBN_Click(object sender, EventArgs e)
        {
            DefinitionForm definitionForm = new DefinitionForm( new DictionaryWord( string.Empty, string.Empty ) );
            DialogResult dialogResult = definitionForm.ShowDialog();

            if( dialogResult == DialogResult.OK )
            {
                for( int i = 0; i < project.DictionaryWords.Count; i++ )
                {
                    if( definitionForm.Definition.Name.CompareTo( project.DictionaryWords[i].Name ) < 0 )
                    {
                        project.DictionaryWords.Insert( i, definitionForm.Definition );

                        return;
                    }
                }

                project.DictionaryWords.Add( definitionForm.Definition );
            }
        }

        private void changeBN_Click(object sender, EventArgs e)
        {
            if( wordsLB.SelectedIndex < 0 ) return;

            DictionaryWord dictionaryWord = wordsLB.SelectedItem as DictionaryWord;

            if( dictionaryWord != null )
            {
                DefinitionForm definitionForm = new DefinitionForm( dictionaryWord );
                DialogResult dialogResult = definitionForm.ShowDialog();

                if( dialogResult == DialogResult.OK ) project.Saved = false;
             }
        }

        private void removeBN_Click(object sender, EventArgs e)
        {
            if( wordsLB.SelectedIndex < 0 ) return;

            project.DictionaryWords.RemoveAt( wordsLB.SelectedIndex );

            project.Saved = false;
        }

        private void wordsLB_SelectedIndexChanged(object sender, EventArgs e)
        {
            if( wordsLB.SelectedIndex < 0 ) return;

            DictionaryWord dictionaryWord = wordsLB.SelectedItem as DictionaryWord;

            if( dictionaryWord != null ) definitionTB.Text = dictionaryWord.Definition;
            else definitionTB.Text = string.Empty;
        }

        private void confirmBN_Click(object sender, EventArgs e)
        {

        }
    }
}
