﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Editor.Project;

namespace UseCaseTool.Forms
{
    public partial class InsertVariationForm : Form
    {
        private BindingList<Variation> variations;
        public int variationIndex;

        public EVariationGroup VariationGroup
        {
            get 
            { 
                if( normalcaseRB.Checked ) return EVariationGroup.Normal;
                else if( lowercaseRB.Checked ) return EVariationGroup.Lowercase;
                else return EVariationGroup.Uppercase;
            }
        }

        public int VariationIndex
        {
            get { return variationIndex; }
        }

        public InsertVariationForm( Actor actor )
        {
            variationIndex = -1;
            variations = actor.Variations;

            InitializeComponent();

            FillListBox();
        }

        public InsertVariationForm( DictionaryWord dictionaryWord )
        {
            variationIndex = -1;
            variations = dictionaryWord.Variations;

            InitializeComponent();

            FillListBox();
        }

        private void variationsLB_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if( e.Button != MouseButtons.Left ) return;

            variationIndex = variationsLB.IndexFromPoint(e.Location);
            
            if( variationIndex != -1 ) DialogResult = DialogResult.OK;
        }

        private void FillListBox()
        {
            variationsLB.BeginUpdate();

            variationsLB.Items.Clear();

            if( normalcaseRB.Checked )
            {
                for( int i = 0; i < variations.Count; i++ )
                    variationsLB.Items.Add( variations[i].Normal );
            }
            else if( lowercaseRB.Checked )
            {
                for( int i = 0; i < variations.Count; i++ )
                    variationsLB.Items.Add( variations[i].Lowercase );
            }
            else
            {
                for( int i = 0; i < variations.Count; i++ )
                    variationsLB.Items.Add( variations[i].Uppercase );
            }

            variationsLB.EndUpdate();
        }

        private void normalcaseRB_CheckedChanged(object sender, EventArgs e)
        {
            if( normalcaseRB.Checked == true ) FillListBox();
        }

        private void lowercaseRB_CheckedChanged(object sender, EventArgs e)
        {
            if( lowercaseRB.Checked == true ) FillListBox();
        }

        private void uppercaseRB_CheckedChanged(object sender, EventArgs e)
        {
            if( uppercaseRB.Checked == true ) FillListBox();
        }
    }
}
